import "core-js/modules/es6.object.assign";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import * as React from 'react'; // const hoistNonReactStatic = require('hoist-non-react-statics');
// import {hoistNonReactStatic} from 'hoist-non-react-statics';

import hoistNonReactStatic from 'hoist-non-react-statics'; // @ts-ignore

function dealSize(Com, removeParentPadding) {
  var SizeProvider =
  /*#__PURE__*/
  function (_React$PureComponent) {
    _inherits(SizeProvider, _React$PureComponent);

    function SizeProvider() {
      var _this;

      _classCallCheck(this, SizeProvider);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(SizeProvider).apply(this, arguments));
      _this.state = {};
      return _this;
    }

    _createClass(SizeProvider, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        if (this.anyComponent && removeParentPadding) {
          var node = this.anyComponent.parentElement;

          if (node) {
            node.style.padding = '0px';
            node.style.border = 'none';
          }
        }

        this.getSize();
      }
    }, {
      key: "getSize",
      value: function getSize() {
        var _this$state = this.state,
            pWidth = _this$state.pWidth,
            pHeight = _this$state.pHeight;

        if (this.anyComponent) {
          var newH = this.anyComponent.clientHeight;
          var newW = this.anyComponent.clientWidth;

          if (pWidth && pHeight && pWidth == newW && pHeight == newH) {
            return;
          } else {
            this.setState({
              pHeight: newH,
              pWidth: newW
            });
          }
        }
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        this.getSize();
      }
    }, {
      key: "render",
      value: function render() {
        var _this2 = this;

        return React.createElement("div", {
          style: {
            width: '100%',
            height: '100%'
          },
          ref: function ref(anyComponent) {
            _this2.anyComponent = anyComponent;
          }
        }, React.createElement(Com, Object.assign({}, this.props, this.state)));
      }
    }]);

    return SizeProvider;
  }(React.PureComponent);

  hoistNonReactStatic(SizeProvider, Com);
  return SizeProvider;
}

export default dealSize;